package com.yfoliage.getmusiclistmore;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.MediaStore;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class MusicAdapter extends BaseAdapter {
	// ContentProvider(ݿ)
	public ContentResolver cr;
	// װѯļ
	public Cursor cur;
	// Ϣб
	public List<MusicInfo> musicList;
	public Context context;

	public MusicAdapter(Context context) {
		this.context = context;
		// ȡݿ
		cr = context.getContentResolver();
		musicList = new ArrayList<MusicInfo>();

		String[] mString = new String[] { MediaStore.Audio.Media.DISPLAY_NAME,
				MediaStore.Audio.Media.ALBUM, MediaStore.Audio.Media.ARTIST,
				MediaStore.Audio.Media.DURATION, MediaStore.Audio.Media.SIZE,
				MediaStore.Audio.Media.ALBUM_ID, MediaStore.Audio.Media.DATA };
		// ѯϢ
		cur = cr.query(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, mString,
				null, null, null);

		if (cur != null) {
			// ƶα굽һ
			cur.moveToFirst();
			int j = 1;
			for (int i = 0; i < cur.getCount(); i++) {
				if (cur.getString(0).endsWith(".mp3")) {// ˻ȡMP3ļ
					MusicInfo mInfo = new MusicInfo();
					String musicName = cur.getString(0).substring(0,
							cur.getString(0).lastIndexOf(".mp3"));
					mInfo.setMusicIndex(j++);
					mInfo.setMusicName(musicName);
					mInfo.setMusicAlubm(cur.getString(1));
					mInfo.setMusicSinger(cur.getString(2));
					mInfo.setMusicTime(cur.getInt(3));
					mInfo.setMusicSize(cur.getInt(4));
					mInfo.setMusicId(cur.getInt(5));
					mInfo.setMusicPath(cur.getString(6));
					musicList.add(mInfo);
				}
				cur.moveToNext();
			}

		}
	}

	@Override
	public int getCount() {
		return musicList.size();
	}

	@Override
	public Object getItem(int arg0) {
		return musicList.get(arg0);
	}

	@Override
	public long getItemId(int arg0) {
		return arg0;
	}

	@Override
	public View getView(int arg0, View arg1, ViewGroup arg2) {
		LayoutInflater mlistLayout = LayoutInflater.from(context);
		View mlistView = mlistLayout.inflate(R.layout.musiclist, null);
		TextView songName = (TextView) mlistView.findViewById(R.id.listName);
		TextView singerName = (TextView) mlistView
				.findViewById(R.id.list_Singer);
		ImageView songImage = (ImageView) mlistView
				.findViewById(R.id.listImage);
		int mid = musicList.get(arg0).getMusicIndex();
		String musicName = musicList.get(arg0).getMusicName();
		String musciSinger = musicList.get(arg0).getMusicSinger();
		if (musciSinger.contains("<unknown>")) {
			musciSinger = "<δ֪>";
		}
		Bitmap img = getAlbumArt(musicList.get(arg0).getMusicId());
		songName.setText(mid + ". " + musicName);
		singerName.setText(musciSinger);
		songImage.setImageBitmap(img);
		return mlistView;
	}

	/**
	 * רͼƬʾ,иͼƬŻ᷵أΪĬϵͼƬ
	 * 
	 * @param albumId
	 *            רַ
	 * @return Bitmap
	 */
	public Bitmap getAlbumArt(int albumId) {// albumIdרid
		Bitmap bitmap = null;
		Uri sArtworkUri = Uri.parse("content://media/external/audio/albumart");
		Uri albumArtUri = ContentUris.withAppendedId(sArtworkUri, albumId);

		try {
			bitmap = MediaStore.Images.Media.getBitmap(
					context.getContentResolver(), albumArtUri);
			bitmap = Bitmap.createScaledBitmap(bitmap, 30, 30, true);

		} catch (FileNotFoundException exception) {
			exception.printStackTrace();
			bitmap = BitmapFactory.decodeResource(context.getResources(),
					R.drawable.album);
		} catch (IOException e) {

			e.printStackTrace();
		}

		return bitmap;
	}
}
